
;ID3DXBaseMesh
;la fentre est cre,sans tre visible
;on lui donne des possibilites graphiques directx
;################################################################
InitD3D PROC  hWnd:DWORD 
			Local  d3dpp:D3DPRESENT_PARAMETERS
			Local FAILED:SDWORD
			Local  retour:DWORD
			ZEROLOCALES retour	
			
		invoke Direct3DCreate9,D3D_SDK_VERSION
		.if eax != 0
			mov ppvIDirect3D9,eax
			mov retour,eax
			mov d3dpp.Windowed,TRUE
			mov d3dpp.SwapEffect,D3DSWAPEFFECT_DISCARD
			mov d3dpp.BackBufferFormat,D3DFMT_UNKNOWN
			;la fonction suivante ne fonctionne pas dans WM_CREATE
			;D3DADAPTER_DEFAULT utilisation du device par dfaut,si plusieurs carte graphiques
			;on peut en spcifi une particulire 
			;D3DDEVTYPE_HAL ,on demande le HAL,Hardware device au lieu du software device
			;D3DCREATE_SOFTWARE_VERTEXPROCESSING ,Software vertex processing permet d'utiliser
			;toutes les cartes graphiques.Les cartes graphiques supportant le hardware vertex processing
			;offrent des performances notablement suprieures
			;Ceci accroit  les performances D3DCREATE_MIXED_VERTEXPROCESSING D3DCREATE_SOFTWARE_VERTEXPROCESSING
			IDirect3D9 CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL, hWnd,\
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,\
                                      addr d3dpp, addr ppvIDirect3DDevice9
			.if eax == D3D_OK		;0
				;rajout
    				; Turn off culling, so we see the front and back of the triangle
				IDirect3DDevice9  SetRenderState,D3DRS_CULLMODE, D3DCULL_NONE 

    				;Turn off D3D lighting, since we are providing our own vertex colors
    				IDirect3DDevice9  SetRenderState,D3DRS_LIGHTING, FALSE 		
				mov retour,1	;sinon retour = 0
				;la fonction fournit le pointeur sur l'interface IDirect3DDevice9
			.endif 
			;c'est fait ,on peut maintenant visualiser la fentre 
			;la fentre D3D doit tre rafraichit de manire particulire dans WM_PAINT			
			
		.endif
 FindeInitD3D:
         mov eax,retour
         ret
InitD3D endp
;tout de suite aprs avoir crer le device
;################################################################

InitVB PROC uses esi edi
			Local  retour:DWORD
			Local  vertices[3]:CUSTOMVERTEX
         	mov retour,0
comment 
	la definition du triangle change par rapport aux prcdants exemples
        { -1.0f,-1.0f, 0.0f, 0xffff0000, },
        {  1.0f,-1.0f, 0.0f, 0xff0000ff, },
        {  0.0f, 1.0f, 0.0f, 0xffffffff, },





		;remplir le buffer
		mov vertices[0].x,RETR4 (-1.0f)
		mov vertices[0].y,RETR4 (-1.0f)
		mov vertices[0].z,RETR4 (0.0f)	
		mov vertices[0].color,0ffff0000h		;ARGB format 0FF..
		;--------------------------------------
		mov vertices[sizeof CUSTOMVERTEX * 1].x,RETR4 (1.0f)
		mov vertices[sizeof CUSTOMVERTEX * 1].y,RETR4 (-1.0f)
		mov vertices[sizeof CUSTOMVERTEX * 1].z,RETR4 (0.0f)	
		mov vertices[sizeof CUSTOMVERTEX * 1].color,0ff0000ffh		;ARGB format		
		;---------------------------------------
		mov vertices[sizeof CUSTOMVERTEX * 2].x,RETR4 (0.0f)
		mov vertices[sizeof CUSTOMVERTEX * 2].y,RETR4 (1.0f)
		mov vertices[sizeof CUSTOMVERTEX * 2].z,RETR4 (0.0f)	
		mov vertices[sizeof CUSTOMVERTEX * 2].color,0ffffffffh		;ARGB format		
		;---------------------------------------		
		;le vertex buffer est un FVF buffer (accs com)
		;il faut crer un buffer FVF puis le remplir
		IDirect3DDevice9 CreateVertexBuffer,3*sizeof(CUSTOMVERTEX),\
			0, D3DFVF_CUSTOMVERTEX,D3DPOOL_DEFAULT,addr ppvIDirect3DVertexBuffer9, NULL
		;la fonction retourne une interface pour manipuler le buffer
		.if eax == D3D_OK	
			;remplir le buffer com
			;obtenir un pointeur en data com
			IDirect3DVertexBuffer9 Lock1,0,sizeof vertices,addr pvertices,NULL
			;ppbData ,pvertices peut entrainer confusion avec original
			.if eax == D3D_OK			
				;on a le pointeur en data com
				mov ecx,sizeof vertices
				cld
				lea esi,vertices
				mov edi,pvertices
				rep movsb	
				IDirect3DVertexBuffer9 Unlock
				.if eax != D3D_OK						
					invoke MessageBox,NULL,SADR("zut"),SADR("Titre"),MB_OK
				.endif				
				mov retour,1
			.endif
		.endif
		;le pointeur en data com est dfinitivement perdu
 FindeInitVB:
         mov eax,retour
         ret
InitVB endp

;################################################################

SetupMatrices PROC uses edi esi
	;incertitude,alignement en pile ?
	.LISTALL
		Local iTime:DWORD
		align 16		;obligatoire
		local matWorld:D3DXMATRIXA16 
		align 16
		local matView:D3DXMATRIXA16
		align 16
		local matProj:D3DXMATRIXA16		
		LOcal vEyePt	:STD3DXVECTOR3
		Local vLookatPt	:STD3DXVECTOR3
		Local vUpVec	:STD3DXVECTOR3
		Local tv153	:REAL8
		Local Angle		:DWORD
		Local  retour:DWORD
		ZEROLOCALES retour
		
		invoke timeGetTime ;temps en ms
		xor	edx, edx
		mov	ecx, 1000				;UINT  iTime  = timeGetTime() % 1000;
		div	ecx
		mov iTime,edx			;on garde le reste = Nombre de 0  999		
		;-------- calcul de l'angle de rotation en radians --------------
		mov	eax, iTime
		mov	DWORD PTR tv153[0], eax
		mov	DWORD PTR tv153[4], 0
		fild	QWORD PTR tv153		;charge le nombre de millimes de tour
		fmul	QWORD PTR DeuxPI		;* (2*PI) , un tour radian
		fdiv	QWORD PTR UnMille		;on retrouve une fraction de tour en radians < 6,28
		fstp	DWORD PTR Angle		;charg dans l'angle
		;-------------------------------------------------------------
   		; Set up the rotation matrix to generate 1 full rotation (2*PI radians) 
		; every 1000 ms. To avoid the loss of precision inherent in very high 
		; floating point numbers, the system time is modulated by the rotation 
		; period before conversion to a radian angle. 
		invoke D3DXMatrixRotationY,addr matWorld,Angle 
		IDirect3DDevice9 SetTransform,D3DTS_WORLD,addr matWorld
		; Set up our view matrix. A view matrix can be defined given an eye point,
		; a point to lookat, and a direction for which way is up. Here, we set the
		; eye five units back along the z-axis and up three units, look at the
		; origin, and define "up" to be in the y-direction.	
		;initialiser a chaque proc	
		;REMPLIR LES STRUCTURES
		;------------------------------------
		lea ecx,vEyePt
		invoke D3DXVECTOR3,FR4(0.0f),FR4(3.0f),FR4(-5.0f)
		;-----------------------------
		lea ecx,vLookatPt
		invoke D3DXVECTOR3,FR4 ( 0.0f),FR4 (0.0f),FR4 (0.0f)
		;------------------------------
		lea ecx,vUpVec		
		invoke D3DXVECTOR3,FR4 (0.0f),FR4(1.0f),FR4(0.0f)
		;---------------------------------	
		;remplir la matrice ?????? just use stack and release
		;lea	ecx,matView
		;call	RemplirMatrice		; _D3DXMATRIXA16::_D3DXMATRIXA16
		
		invoke D3DXMatrixLookAtLH, addr matView,addr vEyePt,addr vLookatPt,addr vUpVec
    		IDirect3DDevice9 SetTransform,D3DTS_VIEW,addr matView
		; For the projection matrix, we set up a perspective transform (which
		; transforms geometry from 3D view space to 2D viewport space, with
		; a perspective divide making objects smaller in the distance). To build
		; a perpsective transform, we need the field of view (1/4 pi is common),
		; the aspect ratio, and the near and far clipping planes (which define at
		;what distances geometry should be no longer be rendered).		
		invoke D3DXMatrixPerspectiveFovLH,addr matProj, UnQuartPi,\
			FR4 ( 1.0f),FR4 ( 1.0f),FR4 ( 100.0f) 
		;return a Pointer to a D3DXMATRIX structure that is a left-handed perspective
		; projection matrix
		IDirect3DDevice9 SetTransform, D3DTS_PROJECTION, addr matProj
	.NOLIST
         mov retour,1
  ; For our world matrix, we will just rotate the object about the y-axis.

 FindeSetupMatrices:
         mov eax,retour
         ret

SetupMatrices endp

;################################################################


;################################################################
Render PROC 
			Local Zreel:DWORD
			Local  retour:DWORD
         mov retour,1
	.if ppvIDirect3DDevice9 != 0
		;arriere plan bleu
		R4MOV Zreel,1.0f	;normalement de 0 a 1
		invoke RGBcolorARGB,0,NULL		;noir
		mov ecx,eax
		;erreur traduction D3DCLEAR_ZBUFFER
		IDirect3DDevice9 Clear,0, NULL,D3DCLEAR_TARGET,ecx,Zreel, 0 
		IDirect3DDevice9 BeginScene
		.if eax != D3D_OK	
			call MessageNotD3D_OK
		.else
		
        		; Setup the world, view, and projection matrices
			IF Exceptions EQ 1	
				;XPEXCEPT SetupMatrices
			ELSE
        			invoke SetupMatrices
			ENDIF
			
			;----------------- ajout triangle -------------------------
			; Draw the triangles in the vertex buffer. This is broken into a few
			; steps. We are passing the vertices down a "stream", so first we need
			; to specify the source of that stream, which is our vertex buffer. Then
			; we need to let D3D know what vertex shader to use. Full, custom vertex
			; shaders are an advanced topic, but in most cases the vertex shader is
			; just the FVF, so that D3D knows what type of vertices we are dealing
			; with. Finally, we call DrawPrimitive() which does the actual rendering
			; of our geometry (in this case, just one triangle).
			IDirect3DDevice9 SetStreamSource,0,ppvIDirect3DVertexBuffer9, 0, sizeof CUSTOMVERTEX
			IDirect3DDevice9 SetFVF,D3DFVF_CUSTOMVERTEX
			;D3DPT_TRIANGLESTRIP D3DPT_TRIANGLELIST
			IDirect3DDevice9 DrawPrimitive,D3DPT_TRIANGLESTRIP, 0, 1			
			;----------------------------------------------------------
			IDirect3DDevice9 EndScene
		.endif
		IDirect3DDevice9 Present,NULL, NULL, NULL, NULL
	.endif
	
 FindeRender:
         mov eax,retour
         ret
MessageNotD3D_OK:	
	pop eax    ;toujours garder l'quilibre de la pile en push pop
	invoke MessageBox,NULL,SADR("Render not D3D_OK") ,SADR("Erreur Quitte"),MB_OK
	jmp FindeRender ;retour = 0
retn
Render endp
;la fonction ne fait qu'une seule chose
;plac les rels dans la structure
;reoit l'adresse de la structure par ecx
;_this,est un terme,en principe,reserv au pointeur com(introduisant le ppv)
;ii,aucune manipulation de pointeur,tout est direct
;plus confus ,ce n'est pas possible
;################################################################
D3DXVECTOR3 PROC  fx:REAL4,  fy:REAL4,  fz:REAL4 
		local _this:DWORD
		Local  retour:DWORD
      mov retour,1
	mov	_this, ecx
;il faut comprendre structure.x = fx	structure = STD3DXVECTOR3
; x = fx;
	mov	eax, _this
	fld	DWORD PTR fx
	fstp	DWORD PTR [eax]		
;  y = fy;
	mov	eax, _this
	fld	DWORD PTR fy
	fstp	DWORD PTR [eax+4]
; z = fz;
	mov	eax, _this
	fld	DWORD PTR fz
	fstp	DWORD PTR [eax+8]
;

	PuPo retour,_this
 FindeD3DXVECTOR3:
         mov eax,retour
         ret
D3DXVECTOR3 endp
;The following one do nothing,he is only here because the c++ add
;it in his code.Look the desassembly of the c++ sample matrices
;and search _D3DXMATRIXA16::_D3DXMATRIXA16
;the only thing he do is using stack memory
;ecx contient l'adresse d'une matrice,D3DXMATRIXA16
;################################################################
;----------------------------------------------------------------
.LISTALL
OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
RemplirMatrice PROC			; _D3DXMATRIXA16::_D3DXMATRIXA16, COMDAT
	local  _this:DWORD
	push	ebp
	mov	ebp, esp	
	sub	esp, 68			; 00000044H
	mov	_this, ecx			;adresse D3DXMATRIXA16
	mov	ecx,_this
	call	D3DXMATRIX			; D3DXMATRIX::D3DXMATRIX
	mov	eax,_this
	mov	esp, ebp
	pop	ebp	
	ret	0				;!attention,on construit un espace pile
RemplirMatrice ENDP			; _D3DXMATRIXA16::_D3DXMATRIXA16
.NOLIST
D3DXMATRIX PROC				; D3DXMATRIX::D3DXMATRIX, COMDAT
	Local _this:DWORD
	push	ebp
	mov	ebp, esp		
	sub	esp, 68			; 00000044H
	mov	_this, ecx
	mov	eax, DWORD PTR _this
	mov	esp, ebp
	pop	ebp		
	ret 0					;!attention,on construit un espace pile
D3DXMATRIX ENDP				; D3DXMATRIX::D3DXMATRIX
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

;################################################################
RGBcolorARGB PROC  RGB:DWORD,  ARGB:DWORD 
			Local  retour:DWORD
		;plein les mirettes
		;Red Green Blue RGB donne aprs decalage 00BGR
		;ARGB donne aprs dcalage ARGB
		;ARGB color macro pour extraction,extraire sparment du RGB
		;0000FFFFh jaune RGB B=00 G=FF R=FF     ARGB 0FFFFFF00h
		;#define RGB(r, g ,b)  (r | g << 8 | b << 16 )
		;#define D3DCOLOR_ARGB(a,r,g,b)((a)&0xff)<<24)|(r)<<16)|g <<8|(b)		
			
      mov retour,0
	.if ARGB == 0	
		;on veut une couleur ARGB
		and edx,0FF000000h	;
		mov eax,RGB
		and eax,0FF0000h  ;bleu
		shr eax,16		
		or edx,eax
		mov eax,RGB
		and eax,0FF00h	;green vert
		or edx,eax
		mov eax,RGB
		and eax,0FFh	;rouge
		shl eax,16
		or edx,eax
		mov retour,edx				
	.else		
		;on veut une couleur RGB
		and edx,0
		mov eax,ARGB
		and eax,0FF0000h  ;rouge
		shr eax,16		
		or edx,eax
		mov eax,ARGB
		and eax,0FF00h	;green vert
		or edx,eax
		mov eax,ARGB
		and eax,0FFh	;Bleu		
		shl eax,16
		or edx,eax
		mov retour,edx						
		
	.endif

 FindeRGBcolorARGB:
         mov eax,retour
         ret
RGBcolorARGB endp





;################################################################

Cleanup PROC      ;relache les interfaces
			Local  retour:DWORD
         mov retour,1
	.if ppvIDirect3DVertexBuffer9 != 0
		IDirect3DVertexBuffer9 Release
		mov ppvIDirect3DVertexBuffer9,0
	.endif

	.if ppvIDirect3DDevice9 != 0
		IDirect3DDevice9 Release
		mov ppvIDirect3DDevice9,0
	.endif
	.if ppvIDirect3D9 != 0
		IDirect3D9 Release
		mov ppvIDirect3D9,0
	.endif

 FindeCleanup:
         mov eax,retour
         ret
Cleanup endp

;################################################################

